> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mirurobotics.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Archive

> Archive staged or drifted deployments.

| Scope                 | Required |
| --------------------- | -------- |
| `deployments:archive` | Yes      |


## OpenAPI

````yaml /references/platform-api/2026-03-09.yaml post /deployments/{deployment_id}/archive
openapi: 3.0.3
info:
  title: Miru Platform API
  description: The API between Miru and any external client
  version: 2026-03-09.tetons
  license:
    name: MIT
    url: https://opensource.org/licenses/MIT
  x-release-version: 2026-03-09.tetons
  x-git-commit:
    sha: a33cf62e35e950971e3c223d746ae8e4e6464442
    url: >-
      https://github.com/mirurobotics/openapi/commit/a33cf62e35e950971e3c223d746ae8e4e6464442
    message: |-
      refactor(stainless): rename config instance content method to download

      Co-Authored-By: Claude Opus 4.6 <noreply@anthropic.com>
    author: Benjamin Smidt
    branch: HEAD
    dirty: false
  x-build:
    built_at: '2026-03-08T22:30:32.695898+00:00'
servers:
  - url: https://api.mirurobotics.com/beta
    description: Miru Platform API
security:
  - ApiKeyAuth: []
paths:
  /deployments/{deployment_id}/archive:
    parameters:
      - $ref: '#/components/parameters/MiruVersion'
    post:
      tags:
        - Deployments
      summary: Archive
      description: Archive staged or drifted deployments.
      operationId: archiveDeployment
      parameters:
        - $ref: '#/components/parameters/deployment_id'
        - $ref: '#/components/parameters/deployment_expansions'
      responses:
        '200':
          description: Successfully archived the deployment.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Deployment'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from miru_platform_sdk import Miru

            client = Miru(
                api_key=os.environ.get("MIRU_API_KEY"),  # This is the default and can be omitted
            )
            deployment = client.deployments.archive(
                deployment_id="dpl_123",
            )
            print(deployment.id)
components:
  parameters:
    MiruVersion:
      name: Miru-Version
      in: header
      required: true
      schema:
        type: string
        example: 2026-03-09.tetons
      description: The API version the client was built against.
    deployment_id:
      name: deployment_id
      in: path
      required: true
      description: The unique identifier of the deployment.
      schema:
        type: string
        example: dpl_123
    deployment_expansions:
      name: expand
      in: query
      required: false
      description: Fields to expand on the deployment resource.
      schema:
        type: array
        items:
          $ref: '#/components/schemas/DeploymentExpansion'
        example:
          - device
  schemas:
    Deployment:
      title: Deployment
      allOf:
        - $ref: '#/components/schemas/BaseDeployment'
        - type: object
          properties:
            device:
              allOf:
                - $ref: '#/components/schemas/Device'
              description: Expand the device using 'expand=device' in the query string.
            release:
              allOf:
                - $ref: '#/components/schemas/Release'
              description: Expand the release using 'expand=release' in the query string.
            config_instances:
              type: array
              items:
                $ref: '#/components/schemas/ConfigInstance'
              description: >-
                Expand the config instances using 'expand=config_instances' in
                the query string.
              example:
                - object: config_instance
                  id: cfg_inst_123
                  config_type_name: Motion Control
                  filepath: /v1/motion-control.json
                  created_at: '2021-01-01T00:00:00Z'
                  config_schema_id: cfg_sch_123
                  config_type_id: cfg_typ_123
                - object: config_instance
                  id: cfg_inst_124
                  config_type_name: Localization
                  filepath: /v1/localization.json
                  created_at: '2021-01-01T00:00:00Z'
                  config_schema_id: cfg_sch_124
                  config_type_id: cfg_typ_124
      example:
        object: deployment
        id: dpl_123
        description: Deployment for the motion control config instance
        status: staged
        activity_status: staged
        error_status: none
        target_status: staged
        device_id: dvc_123
        release_id: rls_123
        created_at: '2024-01-01T00:00:00Z'
        updated_at: '2024-01-01T00:00:00Z'
    DeploymentExpansion:
      type: string
      enum:
        - device
        - release
        - config_instances
      x-enum-varnames:
        - DEPLOYMENT_EXPAND_DEVICE
        - DEPLOYMENT_EXPAND_RELEASE
        - DEPLOYMENT_EXPAND_CONFIG_INSTANCES
    BaseDeployment:
      title: Base Deployment
      type: object
      required:
        - object
        - id
        - description
        - status
        - activity_status
        - error_status
        - target_status
        - device_id
        - release_id
        - created_at
        - updated_at
      properties:
        object:
          type: string
          enum:
            - deployment
          example: deployment
          x-stainless-const: true
          description: The object type, which is always `deployment`.
        id:
          type: string
          example: dpl_123
          description: ID of the deployment.
        description:
          type: string
          example: Deployment for the motion control config instance
          description: The description of the deployment.
        status:
          $ref: '#/components/schemas/DeploymentStatus'
        activity_status:
          $ref: '#/components/schemas/DeploymentActivityStatus'
        error_status:
          $ref: '#/components/schemas/DeploymentErrorStatus'
        target_status:
          $ref: '#/components/schemas/DeploymentTargetStatus'
        device_id:
          type: string
          example: dvc_123
          description: ID of the device.
        release_id:
          type: string
          example: rls_123
          description: ID of the release.
        created_at:
          type: string
          format: date-time
          example: '2024-01-01T00:00:00Z'
          description: Timestamp of when the device release was created.
        updated_at:
          type: string
          format: date-time
          example: '2024-01-01T00:00:00Z'
          description: Timestamp of when the device release was last updated.
    Device:
      allOf:
        - $ref: '#/components/schemas/BaseDevice'
      example:
        object: device
        id: dvc_123
        name: My Device
        status: online
        agent_version: v1.0.0
        last_connected_at: '2021-01-01T00:00:00Z'
        last_disconnected_at: null
        created_at: '2021-01-01T00:00:00Z'
        updated_at: '2021-01-01T00:00:00Z'
    Release:
      title: Release
      allOf:
        - $ref: '#/components/schemas/BaseRelease'
        - type: object
          properties:
            config_schemas:
              type: array
              items:
                $ref: '#/components/schemas/ConfigSchema'
              description: >-
                Expand the config schemas using 'expand=config_schemas' in the
                query string.
              example:
                - object: config_schema
                  id: cfg_sch_123
                  digest: sha256:1234567890
                  config_type_name: Motion Control
                  instance_filepath: /srv/miru/configs/v1/motion-control.json
                  created_at: '2021-01-01T00:00:00Z'
                  updated_at: '2021-01-01T00:00:00Z'
                  config_type_id: cfg_typ_123
                  language: jsonschema
                  format: json
                - object: config_schema
                  id: cfg_sch_124
                  digest: sha256:1234567890
                  config_type_name: Localization
                  instance_filepath: /srv/miru/configs/v1/localization.json
                  created_at: '2021-01-01T00:00:00Z'
                  updated_at: '2021-01-01T00:00:00Z'
                  config_type_id: cfg_typ_124
                  language: jsonschema
                  format: json
      example:
        object: release
        id: rls_123
        version: v1.0.0
        git_commit_id: git_commit_123
        created_at: '2024-01-01T00:00:00Z'
        updated_at: '2024-01-01T00:00:00Z'
    ConfigInstance:
      title: Config Instance
      allOf:
        - $ref: '#/components/schemas/BaseConfigInstance'
        - type: object
          properties:
            config_schema:
              allOf:
                - $ref: '#/components/schemas/ConfigSchema'
              description: >-
                Expand the config schema using 'expand=config_schema' in the
                query string.
            config_type:
              allOf:
                - $ref: '#/components/schemas/ConfigType'
              description: >-
                Expand the config type using 'expand=config_type' in the query
                string.
            content:
              allOf:
                - $ref: '#/components/schemas/InstanceContent'
              description: >-
                The configuration values associated with the config instance.
                Expand the content using 'expand=content' in the query string.
      example:
        object: config_instance
        id: cfg_inst_123
        config_type_name: Motion Control
        filepath: /v1/motion-control.json
        created_at: '2021-01-01T00:00:00Z'
        config_schema_id: cfg_sch_123
        config_type_id: cfg_typ_123
    DeploymentStatus:
      type: string
      description: >
        This status merges the 'activity_status' and 'error_status' fields, with
        error states taking precedence over activity states when errors are
        present. For example, if the activity status is 'deployed' but the error
        status is 'failed', the status is 'failed'. However, if the error status
        is 'none' and the activity status is 'deployed', the status is
        'deployed'.
      enum:
        - drifted
        - staged
        - queued
        - deployed
        - archived
        - failed
        - retrying
      x-enum-varnames:
        - DEPLOYMENT_STATUS_DRIFTED
        - DEPLOYMENT_STATUS_STAGED
        - DEPLOYMENT_STATUS_QUEUED
        - DEPLOYMENT_STATUS_DEPLOYED
        - DEPLOYMENT_STATUS_ARCHIVED
        - DEPLOYMENT_STATUS_FAILED
        - DEPLOYMENT_STATUS_RETRYING
    DeploymentActivityStatus:
      type: string
      description: >
        Last known activity state of the deployment.

        - Drifted: device's configurations have drifted since this deployment
        was staged, and the deployment needs to be reviewed before it can be
        deployed

        - Staged: is ready to be deployed

        - Queued: the deployment's config instances are waiting to be received
        by the device; will be deployed as soon as the device is online

        - Deployed: the deployment's config instances are currently available
        for consumption on the device

        - Archived: the deployment is available for historical reference but
        cannot be deployed and is not active on the device
      enum:
        - drifted
        - staged
        - queued
        - deployed
        - archived
      x-enum-varnames:
        - DEPLOYMENT_ACTIVITY_STATUS_DRIFTED
        - DEPLOYMENT_ACTIVITY_STATUS_STAGED
        - DEPLOYMENT_ACTIVITY_STATUS_QUEUED
        - DEPLOYMENT_ACTIVITY_STATUS_DEPLOYED
        - DEPLOYMENT_ACTIVITY_STATUS_ARCHIVED
    DeploymentErrorStatus:
      type: string
      description: >
        Last known error state of the deployment.

        - None: no errors

        - Retrying: an error has been encountered and the agent is retrying to
        reach the target status

        - Failed: a fatal error has been encountered; the deployment is archived
        and (if deployed) removed from the device
      enum:
        - none
        - failed
        - retrying
      x-enum-varnames:
        - DEPLOYMENT_ERROR_STATUS_NONE
        - DEPLOYMENT_ERROR_STATUS_FAILED
        - DEPLOYMENT_ERROR_STATUS_RETRYING
    DeploymentTargetStatus:
      type: string
      description: >
        Desired state of the deployment.

        - Staged: is ready to be deployed

        - Deployed: all config instances part of the deployment are available
        for consumption on the device

        - Archived: the deployment is available for historical reference but
        cannot be deployed and is not active on the device
      enum:
        - staged
        - deployed
        - archived
      x-enum-varnames:
        - DEPLOYMENT_TARGET_STATUS_STAGED
        - DEPLOYMENT_TARGET_STATUS_DEPLOYED
        - DEPLOYMENT_TARGET_STATUS_ARCHIVED
    BaseDevice:
      title: Base Device
      type: object
      required:
        - object
        - id
        - name
        - status
        - agent_version
        - last_connected_at
        - last_disconnected_at
        - created_at
        - updated_at
      properties:
        object:
          type: string
          enum:
            - device
          example: device
          x-stainless-const: true
          description: The object type, which is always `device`.
        id:
          type: string
          example: dvc_123
          description: ID of the device.
        name:
          type: string
          example: My Device
          description: Name of the device.
        status:
          $ref: '#/components/schemas/DeviceStatus'
        agent_version:
          type: string
          example: v1.0.0
          description: The version of the agent the device is running.
          nullable: true
        last_connected_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          nullable: true
          description: >-
            Timestamp of when the device was last made an initial connection
            (this is not the same as the last time the device was seen).
        last_disconnected_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          nullable: true
          description: >-
            Timestamp of when the device was last disconnected (this is not the
            same as the last time the device was seen).
        created_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: Timestamp of when the device was created.
        updated_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: Timestamp of when the device was last updated.
    BaseRelease:
      title: Base Release
      type: object
      required:
        - object
        - id
        - version
        - git_commit_id
        - created_at
        - updated_at
      properties:
        object:
          type: string
          enum:
            - release
          example: release
          x-stainless-const: true
          description: The object type, which is always `release`.
        id:
          type: string
          example: rls_123
          description: ID of the release.
        version:
          type: string
          example: v1.0.0
          description: The version of the release.
        git_commit_id:
          type: string
          nullable: true
          example: git_commit_123
          description: The ID of the git commit associated with this release.
        created_at:
          type: string
          format: date-time
          example: '2024-01-01T00:00:00Z'
          description: Timestamp of when the release was created.
        updated_at:
          type: string
          format: date-time
          example: '2024-01-01T00:00:00Z'
          description: Timestamp of when the release was last updated.
    ConfigSchema:
      title: Config Schema
      allOf:
        - $ref: '#/components/schemas/BaseConfigSchema'
        - type: object
          properties:
            config_type:
              allOf:
                - $ref: '#/components/schemas/ConfigType'
              description: >-
                Expand the config type using 'expand=config_type' in the query
                string.
      example:
        object: config_schema
        id: cfg_sch_123
        digest: sha256:1234567890
        config_type_name: Motion Control
        instance_filepath: /srv/miru/configs/v1/motion-control.json
        created_at: '2021-01-01T00:00:00Z'
        updated_at: '2021-01-01T00:00:00Z'
        config_type_id: cfg_typ_123
        language: jsonschema
        format: json
    BaseConfigInstance:
      title: Base Config Instance
      type: object
      required:
        - object
        - id
        - config_type_name
        - filepath
        - created_at
        - config_schema_id
        - config_type_id
      properties:
        object:
          type: string
          enum:
            - config_instance
          example: config_instance
          x-stainless-const: true
          description: The object type, which is always `config_instance`.
        id:
          type: string
          example: cfg_inst_123
          description: ID of the config instance.
        config_type_name:
          type: string
          example: Motion Control
          description: The name of the config type.
        filepath:
          type: string
          example: /srv/miru/configs/v1/motion-control.json
          description: The absolute file system path where this config instance is written.
        created_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: The timestamp of when the config instance was created.
        config_schema_id:
          type: string
          example: cfg_sch_123
          description: ID of the config schema which the config instance must adhere to.
        config_type_id:
          type: string
          example: cfg_type_123
          description: >-
            ID of the config type which the config instance (and its schema) is
            a part of.
    ConfigType:
      allOf:
        - $ref: '#/components/schemas/BaseConfigType'
      example:
        object: config_type
        id: cfg_typ_123
        name: Motion Control
        slug: motion-control
        created_at: '2021-01-01T00:00:00Z'
        updated_at: '2021-01-01T00:00:00Z'
        created_by_id: usr_123
        updated_by_id: usr_123
    InstanceContent:
      title: Instance Content
      type: object
      required:
        - format
        - data
      properties:
        format:
          $ref: '#/components/schemas/InstanceFormat'
        data:
          type: string
          description: The configuration values associated with the config instance.
          example: |
            {
              "enable_autonomy": true,
              "enable_remote_control": true,
              "max_payload_kg": 10.0
            }
      example:
        format: json
        data: |
          {
            "enable_autonomy": true,
            "enable_remote_control": true,
            "max_payload_kg": 10.0
          }
    DeviceStatus:
      type: string
      description: >
        The status of the device.

        - Inactive: The miru agent has not yet been installed / authenticated

        - Activating: The miru agent is currently being installed /
        authenticated (should only last for a few seconds)

        - Online: The miru agent has successfully pinged the server within the
        last 60 seconds.

        - Offline: The miru agent has not successfully pinged the server within
        the last 60 seconds (e.g. network issues, device is powered off, etc.)
      enum:
        - inactive
        - activating
        - online
        - offline
      x-enum-varnames:
        - DEVICE_STATUS_INACTIVE
        - DEVICE_STATUS_ACTIVATING
        - DEVICE_STATUS_ONLINE
        - DEVICE_STATUS_OFFLINE
    BaseConfigSchema:
      title: Base Config Schema
      type: object
      required:
        - object
        - id
        - digest
        - config_type_name
        - instance_filepath
        - created_at
        - updated_at
        - config_type_id
        - language
        - format
      properties:
        object:
          type: string
          enum:
            - config_schema
          example: config_schema
          x-stainless-const: true
          description: The object type, which is always `config_schema`.
        id:
          type: string
          example: cfg_sch_123
          description: ID of the config schema.
        digest:
          type: string
          example: sha256:1234567890
          description: The digest of the config schema.
        config_type_name:
          type: string
          example: Motion Control
          description: The name of the config type.
        instance_filepath:
          type: string
          description: >-
            The absolute file system path where config instances for this schema
            are written.
          example: /srv/miru/configs/v1/motion-control.json
        created_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: Timestamp of when the config schema was created.
        updated_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: Timestamp of when the config schema was last updated.
        config_type_id:
          type: string
          example: cfg_typ_123
          description: ID of the config type.
        language:
          $ref: '#/components/schemas/SchemaLanguage'
        format:
          $ref: '#/components/schemas/SchemaFormat'
        documents:
          allOf:
            - $ref: '#/components/schemas/SchemaDocuments'
          description: >-
            Expand the config schema documents using `expand=documents` in the
            query string.
          example:
            - id: doc_123
              name: main.json
              data: |
                {
                  "$schema": "https://json-schema.org/draft/2020-12/schema",
                  "type": "object"
                }
    BaseConfigType:
      title: Config Type
      type: object
      required:
        - object
        - id
        - name
        - slug
        - created_at
        - updated_at
      properties:
        object:
          type: string
          enum:
            - config_type
          example: config_type
          x-stainless-const: true
          description: The object type, which is always `config_type`.
        id:
          type: string
          example: cfg_123
          description: ID of the config type.
        name:
          type: string
          example: My Config Type
          description: Name of the config type.
        slug:
          type: string
          example: my-config-type
          description: An immutable, code-friendly name for the config type.
        created_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: Timestamp of when the config type was created.
        updated_at:
          type: string
          format: date-time
          example: '2021-01-01T00:00:00Z'
          description: Timestamp of when the config type was last updated.
    InstanceFormat:
      title: Instance Format
      type: string
      enum:
        - json
      x-enum-varnames:
        - INSTANCE_FORMAT_JSON
    SchemaLanguage:
      title: Schema Language
      type: string
      example: jsonschema
      enum:
        - jsonschema
        - cue
      x-enum-varnames:
        - JSONSCHEMA
        - CUE
    SchemaFormat:
      title: Schema Format
      type: string
      enum:
        - json
        - yaml
        - cue
      x-enum-varnames:
        - SCHEMA_FORMAT_JSON
        - SCHEMA_FORMAT_YAML
        - SCHEMA_FORMAT_CUE
    SchemaDocuments:
      type: array
      items:
        $ref: '#/components/schemas/SchemaDocument'
      example:
        - id: doc_123
          name: main.json
          data: |
            {
              "$schema": "https://json-schema.org/draft/2020-12/schema",
              "type": "object"
            }
    SchemaDocument:
      title: Schema Document
      type: object
      required:
        - id
        - name
        - data
      properties:
        id:
          type: string
          description: The unique identifier for this document.
          example: doc_123
        name:
          type: string
          description: The document filename.
          example: main.json
        data:
          type: string
          description: The raw document content.
      example:
        id: doc_123
        name: main.json
        data: |
          {
            "$schema": "https://json-schema.org/draft/2020-12/schema",
            "type": "object"
          }
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-Key
      description: The API key to use for authentication.

````